
CoCoA-5 - Feature #1122

New fn: RandomLinearForm

15 Nov 2017 17:01 - John Abbott

Status: Closed Start date: 15 Nov 2017

Priority: Normal Due date:  

Assignee: Anna Maria Bigatti % Done: 100%

Category: CoCoA-5 function: new Estimated time: 0.99 hour

Target version: CoCoA-5.2.4 Spent time: 0.95 hour

Description

Should we add a new function RandomLinearForm?

What should its arg(s) be?

Split off from issue #1067.

Related issues:

Related to CoCoA-5 - Design #1067: "Randomize" and "Randomized" obsolete? Closed 14 May 2017

Related to CoCoALib - Feature #1169: New function: RandomLinearForm (CoCoALib) Closed 19 Mar 2018

History

#1 - 15 Nov 2017 17:01 - John Abbott

- Related to Design #1067: "Randomize" and "Randomized" obsolete? added

#2 - 19 Mar 2018 10:23 - Anna Maria Bigatti

- Related to Feature #1169: New function: RandomLinearForm (CoCoALib) added

#3 - 19 Mar 2018 10:25 - Anna Maria Bigatti

- Status changed from New to Feedback

- Assignee set to Anna Maria Bigatti

- % Done changed from 0 to 80

Implemented in CoCoALib. See  Feature #1169

#4 - 16 May 2018 15:10 - John Abbott

I have just tried calling RandomLinearForm with a large ring containing 10000 indets; it took 1 minute, which is SLOW.

Why?

NOTE  Ouch!  I have just tried the same but with a ring containing 5000 indets; it took 8s.  This suggests CUBIC COMPLEXITY???  There must be

something wrong!

#5 - 16 May 2018 16:36 - John Abbott

I have reversed the loop in RandomLinearForm (in SparsePolyRing.C).  Now it is significantly faster.

But why was it so slow before; I thought we handled specially that case... evidently not :-(

Maybe we could use PushBack??

25 Apr 2024 1/2

https://cocoa.dima.unige.it/redmine/issues/1067
https://cocoa.dima.unige.it/redmine/issues/1169


#6 - 16 May 2018 16:38 - Anna Maria Bigatti

John Abbott wrote:

Maybe we could use PushBack??

 

Depends on the ordering :-(

But we could make special implementations for (deg)lex and degrevlex

#7 - 26 Jul 2018 14:05 - John Abbott

- % Done changed from 80 to 90

It may be more fast-and-robust to use geobuckets... is it worth doing so?

[I have added a comment to the source code SparsePolyOps-RingElem.C:162]

#8 - 30 Jul 2018 14:22 - John Abbott

- Status changed from Feedback to Closed

- % Done changed from 90 to 100

- Estimated time set to 0.99 h

Closing
